/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 31/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapKalenderToHariLibur;
import com.portofolio.entity.vo.MapKalenderToHariLiburId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface MapKalenderToHariLiburDao extends CrudRepository<MapKalenderToHariLibur, MapKalenderToHariLiburId> {

	@Cacheable("MapKalenderToHariLiburDaofindOneBy")
	MapKalenderToHariLibur findOneByIdKdTanggalAndIdKdHariLiburAndIdKdProfile(Integer kdTanggal,
			Integer kdHariLibur, Integer kdProfile);

	@Query(QListAll)
	@Cacheable("MapKalenderToHariLiburDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page);

	@Query(QListAll + " and hariLibur.namaHariLibur like %:namaHariLibur% ")
	@Cacheable("MapKalenderToHariLiburDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaHariLibur") String namaHariLibur,
			Pageable page);

	@Query(QListAll + " and model.id.kdTanggal =:kdTanggal")
	@Cacheable("MapKalenderToHariLiburDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kdTanggal") Integer kdTanggal);

	@Query(QListAll) 
	List<Map<String, Object>> findAllData(@Param("kdProfile") Integer kdProfile);
	
	String QListAll = "select new map(model.id.kdProfile as kdProfile"
			+ ", model.id.kdTanggal as kdTanggal "
			+ ", kalender.tanggal as tanggal "
			+ ", model.id.kdHariLibur as kdHariLibur "
			+ ", hariLibur.namaHariLibur as namaHariLibur " 
			+ ", model.kdPeriode as kdPeriode "
			+ ", periode.namaPeriode as namaPeriode " 
			+ ", periode.kdPeriodeHead as kdPeriodeHead " 
			+ ", periodeHead.namaPeriode as namaPeriodeHead " 
			+ ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec, model.version as version )"
			+ " from MapKalenderToHariLibur model left join model.id id  "
			+ " left join model.profile profile "
			+ " left join model.kalender kalender "
			+ " left join model.hariLibur hariLibur "
			+ " left join model.periode periode "
			+ " left join periode.periodeHead periodeHead "
			+ " where profile.kode =:kdProfile ";
			//+ "and model.statusEnabled = true ";

	/*@Cacheable("countMapKalenderToHariLibur")
	Long countIdKdTanggalByIdKdTanggalAndIdKdProfile(Integer kdTanggal, Integer kdProfile);

	@Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update MapKalenderToHariLibur m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdTanggal =:kdTanggal")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile,
			@Param("kdTanggal") Integer kdTanggal);*/

}
